#!/bin/sh
#   Copyright (c) 2012 digitalSTROM.org, Zurich, Switzerland
#
#   Author: Sergey 'Jin' Bostandzhyan <jin@mediatomb.cc>
#
#   This file is part of digitalSTROM Server.
#
#   netinfo.sh is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   netinfo.sh is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this file. If not, see <http://www.gnu.org/licenses/>.

# avoid sourcing other library files
ERR_OK=0
ERR_DOWAIT=25
ERR_NEED_REBOOT=80

UPDATE_STATUS_UNKNOWN=0

json_ok() {
    echo "{ \"success\": true, \"code\": $ERR_OK, \"message\": \"OK\", \"usb\": $1 }"
}

json_status() {
    echo "{ \"success\": true, \"code\": $1, \"message\": \"$2\", \"usb\": $3 }"
}

json_update_status() {
    UPDATE=$UPDATE_STATUS_UNKNOWN
    if [[ -s /var/lock/systemupdate ]]; then
        CODE=`cat /var/lock/systemupdate 2>/dev/null`
        if [[ -n "$CODE" ]]; then
            UPDATE="$CODE"
        fi
    fi
    MESSAGE=
    if [[ -s /var/cache/updatemessage ]]; then
        MESSAGE=`cat /var/cache/updatemessage 2>/dev/null`
    fi
    echo -n "{ \"success\": true, \"code\": $1, \"status\": $UPDATE "
    if [[ -n "$MESSAGE" ]]; then
        echo -n ", \"message\": \"$MESSAGE\" "
    fi
    echo ", \"usb\": $2 }"
}

echo "Content-Type: application/json"
echo ""

USB=false
if [[ -d /media/dss11usb/dss11-usb-upgrade ]]; then
    USB=true
fi

if [[ -e /var/lock/systemupdate ]] || [[ -e /var/lock/usbupdate ]]; then
    json_update_status $ERR_DOWAIT $USB
    exit 0
fi

if [[ -e /var/lock/rebootafterupdate ]]; then
    json_status $ERR_NEED_REBOOT "The system needs to be rebooted" $USB
    exit 0
fi

json_ok $USB
exit 0
